
package com.baofoo.Demo;

import java.text.SimpleDateFormat;
import java.util.Base64;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

import com.baofoo.Entity.CheckCardResultEntity;
import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.rsa.SignatureUtils;
import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.JXMConvertUtil;
import com.baofoo.util.Log;
import com.baofoo.util.SecurityUtil;

import net.sf.json.JSONObject;

public class Bankcard{
	
	public static void main(String[] args) throws Exception{
		String member_id = "100026913";
		String terminal_id = "200002090";
		String  pfxpath ="D:\\CER\\bfkey_100026913@@200002090.pfx";//商户私钥        
        String  cerpath ="D:\\CER\\bfkey_100026913@@200002090.cer";//宝付公钥
		String pfxpwd = "100026913_364422";//私钥密码
		
		Map<String,String> PostHeadMap = new HashMap<String,String>();
		PostHeadMap.put("member_id", member_id);
		PostHeadMap.put("terminal_id", terminal_id);//报文流水号
		PostHeadMap.put("data_type", "json");
		PostHeadMap.put("encrypt_type", "RSA");
		
		Map<String,String> datacontent = new TreeMap<String,String>();
		datacontent.put("member_id",member_id);
		datacontent.put("terminal_id",terminal_id);
		datacontent.put("trans_id","TID"+System.currentTimeMillis());//商户订单号（自定义订单号）
		datacontent.put("trade_date",new SimpleDateFormat("yyyyMMddHHmmss").format(new Date()));
		datacontent.put("acc_no","6222080302003141097");//银行卡
		datacontent.put("id_card","510824198111087470");//身份证
		datacontent.put("id_holder","罗爱坪");//姓名
		datacontent.put("mobile","13920999831");//手机号
		datacontent.put("card_type","101");//借记卡:101，	信用卡:102
		datacontent.put("id_type","0");//0:身份证,1:军官证,2:护照
		datacontent.put("industry_type","A1");//行业类型   取值：默认A1
		datacontent.put("valid_date","");//(非信用卡传空)信用卡有效期，如：0117（月+年）
		datacontent.put("valid_no","");//(非信用卡传空)信用卡背面3位数字检验码，如：123
		datacontent.put("verify_element","1234");//取值：1234-1：四要素（银行卡号 + 姓名 + 身份证号 + 银行卡预留手机号+账户类型）
		datacontent.put("acc_type","01");//账户类型   01 一类户
		
		String DcStr=JSONObject.fromObject(datacontent).toString();
		Log.Write("业务请求参数："+DcStr);
		
		String base64str = Base64.getEncoder().encodeToString(DcStr.getBytes("UTF-8"));
		String En_DcStr = RsaCodingUtil.encryptByPubCerFile(base64str,cerpath);//加密数据用宝付公钥加密
		
		PostHeadMap.put("data_content", En_DcStr);//放入业务请求参数。
		
		String DcStr2 = PostHeadMap.get("member_id") + PostHeadMap.get("terminal_id")+PostHeadMap.get("data_type")+PostHeadMap.get("data_content")+PostHeadMap.get("encrypt_type");
		Log.Write("拼接成字符串："+DcStr2);
		
		String base64str2 = Base64.getEncoder().encodeToString(DcStr2.getBytes("UTF-8"));
		String Sign = SignatureUtils.encryptByRSA(base64str2, pfxpath, pfxpwd);//签名商户私钥加密
		PostHeadMap.put("data_sign", Sign);
		
		String PostString = HttpUtil.RequestForm("https://vgw.baofoo.com/biztransfer/bankcard/v2/authWithSign", PostHeadMap);
		
		Log.Write("返回数据："+PostString);
		
		JSONObject jsobj= JSONObject.fromObject(PostString);
        CheckCardResultEntity test = (CheckCardResultEntity) JSONObject.toBean(jsobj,CheckCardResultEntity.class);
		 Log.Write("转换为MAP对象："+test.getSuccess());
		
		String RSignVStr = test.getSuccess() + test.getData()+"RSA"+"json";
			Log.Write("拼接成字符串："+RSignVStr);
				
			String RSignature = Base64.getEncoder().encodeToString(RSignVStr.getBytes("UTF-8"));
		if(SignatureUtils.verifySignature(cerpath,RSignature,test.getData_sign())){//签名宝付RSA公钥验签
			Log.Write("Yes");//验签成功
		}
		
			
			String data = SecurityUtil.Base64Decode(RsaCodingUtil.decryptByPriPfxFile(test.getData(), pfxpath, pfxpwd));//加密数据商户私钥解密之后base转码		
			Log.Write("返回解密数据："+data);
		
	
	}	
} 